#include "include/generate.h"
#include "include/spu_timer.h"
#include "include/spu_utils.h"
#include "include/bl_f_d.h"

// this file is compiled both for floats and doubles

void BL_TN(DistGenerateLocalFunc)(void (*gen_func)(BL_DTYPE*, int,int), BlockDistArray* x, int N, enum bl_do_step do_step)
{
	startTimer(&bl_time.total);
	
	// init BarrF handlers
	BArr_Handler baRes;
	init_BArr_Put(&baRes, x, BL_CHSIZE);
	
	if(do_step)
		NestStep_step();
    {	
		while(baRes.currentSize) // get chunks
		{
			startTimer(&bl_time.calc);
			gen_func(baRes.current, baRes.currentStart, baRes.currentSize);
			stopTimer(&bl_time.calc);
			
			put_sw_BArr(&baRes); // put res back
		}

		wait_put_BArr_done(&baRes); // wait for last put
		
		if(do_step)
		{
			startTimer(&bl_time.comb);
			NestStep_combine(NULL,NULL);
			stopTimer(&bl_time.comb);
		}
	}
	if(do_step)
		NestStep_end_step();
	stopTimer(&bl_time.total);
}

static BL_DTYPE (*globalGenFunc)(int) = NULL;

static void localGenGlobalFunc(BL_DTYPE *x, int start, int n)
{
	int i;
	for(i=0;i<n;i++)
		x[i] = globalGenFunc(i + start);
}

void BL_TN(DistGenerate)(BL_DTYPE (*gen_func)(int), BlockDistArray* x, int N, enum bl_do_step do_step)
{
	globalGenFunc = gen_func;
	BL_TN(DistGenerateLocalFunc)(&localGenGlobalFunc, x, N, do_step);
}

