#include "include/generate.h"
#include "include/spu_timer.h"
#include "include/spu_utils.h"
#include "include/bl_f_d.h"

// this file is compiled both for floats and doubles
// same as generate.c except this one works on private arrays

void BL_TN(PrivateGenerateLocalFunc)(void (*gen_func)(BL_DTYPE*, int,int), PrivateArray* x, int N, enum bl_do_step do_step)
{
	startTimer(&bl_time.total);
	
	// init BarrF handlers
	PArr_Handler baRes;
	init_PArr_Put(&baRes, x, BL_CHSIZE);
	
	if(do_step)
		NestStep_step();
    {	
		while(baRes.currentSize) // get chunks
		{
			startTimer(&bl_time.calc);
			gen_func(baRes.current, baRes.currentStart, baRes.currentSize);
			stopTimer(&bl_time.calc);
			
			put_sw_PArr(&baRes); // put res back
		}

		wait_put_PArr_done(&baRes); // wait for last put
		
		if(do_step)
		{
			startTimer(&bl_time.comb);
			NestStep_combine(NULL,NULL);
			stopTimer(&bl_time.comb);
		}
	}
	if(do_step)
		NestStep_end_step();
	stopTimer(&bl_time.total);
}

static BL_DTYPE (*globalGenFunc)(int) = NULL;

static void localGenGlobalFunc(BL_DTYPE *x, int start, int n)
{
	int i;
	for(i=0;i<n;i++)
		x[i] = globalGenFunc(i + start);
}

void BL_TN(PrivateGenerate)(BL_DTYPE (*gen_func)(int), PrivateArray* x, int N, enum bl_do_step do_step)
{
	globalGenFunc = gen_func;
	BL_TN(PrivateGenerateLocalFunc)(&localGenGlobalFunc, x, N, do_step);
}

