#ifndef __SPU_BLAS_H__
#define __SPU_BLAS_H__

#include <NestStep_spulib/neststep_spu.h>
#include "vector_defs.h"
#define NAME_OFFSET 1024
#define NAME_BLAS 6
#define MAX_SPUS 8

// dummy header file. The is no implementation.

enum CBLAS_ORDER {CblasRowMajor=101, CblasColMajor=102};
enum CBLAS_TRANSPOSE {CblasNoTrans=111, CblasTrans=112, CblasConjTrans=113};
// Upper/Lower triangular
enum CBLAS_UPLO {CblasUpper=121, CblasLower=122};
enum CBLAS_DIAG {CblasNonUnit=131, CblasUnit=132};
enum CBLAS_SIDE {CblasLeft=141, CblasRight=142};


dba_saxpy(const int N, const float alpha, BlockDistArray *X,
                 const int incX, BlockDistArray *Y, const int incY);
dba_sdot(const int N, BlockDistArray *X, const int incX, BlockDistArray *Y, const int incY);

dba_sgemv(const enum CBLAS_ORDER order, const enum CBLAS_TRANSPOSE TransA,
              const int M, const int N, const float alpha, const float *A,
			  const int lda, BlockDistArray *X, const int incX, const float beta,
			  BlockDistArray *Y, const int incY);


#endif
