#ifndef __BL_F_D_H__
#define __BL_F_D_H__
#include "bl_common.h"

// macro definitions for float/double builds. Used as a simple form of templates 

#ifndef BUILD_FLOAT
	#ifndef BUILD_DOUBLE
		#define BUILD_FLOAT
	#endif
#endif

// defines for float builds
#ifdef BUILD_FLOAT
#define BL_DTYPE float
#define BL_VSIZE 4
#define BL_DTYPE_SIZE 4
#define BL_TN(f) s##f
#define BL_CHSIZE CHUNKSIZE_F
#define BL_NSTYPE FVAR

#define BArr_Handler BArrF_Handler
#define get_sw_BArr get_sw_BArrF
#define init_BArr_Put init_BArrF_Put
#define init_BArr_Get init_BArrF_Get
#define put_sw_BArr put_sw_BArrF
#define wait_put_BArr_done wait_put_BArrF_done
#define free_BArr_Handler free_BArrF_Handler 

#define PArr_Handler PArrF_Handler
#define get_sw_PArr get_sw_PArrF
#define get_PArr get_PArrF
#define init_PArr_Put init_PArrF_Put
#define init_PArr_Get init_PArrF_Get
#define put_sw_PArr put_sw_PArrF
#define wait_put_PArr_done wait_put_PArrF_done
#define free_PArr_Handler free_PArrF_Handler 
#define get_BArr_dA get_BArrF_dA

#define store_RArr store_RArrF
#define get_RArr get_RArrF

#endif

// defines for double builds
#ifdef BUILD_DOUBLE
#define BL_DTYPE double
#define BL_VSIZE 2
#define BL_DTYPE_SIZE 8
#define BL_TN(f) d##f
#define BL_CHSIZE  CHUNKSIZE_D
#define BL_NSTYPE DVAR

#define BArr_Handler BArrD_Handler
#define get_sw_BArr get_sw_BArrD
#define init_BArr_Put init_BArrD_Put
#define init_BArr_Get init_BArrD_Get
#define put_sw_BArr put_sw_BArrD
#define wait_put_BArr_done wait_put_BArrD_done
#define free_BArr_Handler free_BArrD_Handler 

#define PArr_Handler PArrD_Handler
#define get_sw_PArr get_sw_PArrD
#define init_PArr_Put init_PArrD_Put
#define init_PArr_Get init_PArrD_Get
#define put_sw_PArr put_sw_PArrD
#define wait_put_PArr_done wait_put_PArrD_done
#define get_PArr get_PArrD
#define free_PArr_Handler free_PArrD_Handler 
#define get_BArr_dA get_BArrD_dA

#define store_RArr store_RArrD
#define get_RArr get_RArrD

#endif

#endif
