#ifndef __BL_MP_H__
#define __BL_MP_H__
#include <NestStep_spulib/neststep_spu.h>
#include "vector_defs.h"
#include "bl_common.h"
#define NAME_OFFSET 1024
#define NAME_MP 9
#define ACK_OFFSET 8


// bit ranges i signal register 1:
//  0 -  7: signal available
//  8 - 15: signal ack
// 16 - 23: Group sync
// 24 - 31: Reserved for future expansion

// functions for signal based message passing
void blSendSignal1(volatile unsigned int msg, int target);
unsigned int blRecvSignal1();

void blSendSignal1Bit(int bit, int target);
void blWaitSignal1Bit(int bit);

void blSignal(int target);
void blSignalAck(int target);
void blWaitSignal(int source);
void blWaitSignalAck(int source);


typedef struct _msgPointer
{
	volatile void *data;
	volatile int size;
	volatile int pad[2]; // padded to 16 byte
} msgPointer;

// message passing
void blSendMsg(volatile void * data, int size, int target);
int blRecvMsg(volatile void * data, int source);
void blWaitMsgAck(int source);
void blWaitMsgDMA(int source);

// implicit in blWaitMsgDMA
static inline void blSendMsgAck(int target){blSignalAck(target);}

// syncronisation functions using inter spu message passing
void blGroupSync();
void blMPGroupSync();
void blMPDistSync(volatile void* data, void* localElement, unsigned int elementSize);

#endif
