#ifndef __SPU_TIMER_H__
#define __SPU_TIMER_H__
#include "bl_common.h"
#include <NestStep_spulib/neststep_spu.h>
#define NAME_OFFSET 1024
#define NAME_TIME 7

// timers for blocklib internal performance timers

// look in /proc/cpuinfo (on Linux systems) for the correct time base
// time base for Play Station 3
#define TIMEBASE 79800000

// time base for QS20
//#define TIMEBASE 14318000

typedef struct _spu_timer
{
	long long time;
	unsigned int startTime;
} spu_timer;

typedef struct _spu_timers
{
	spu_timer total;
	spu_timer exec;
	spu_timer dma;
	spu_timer comb;
	spu_timer calc;
} spu_timers;

typedef struct _dTime
{
	double total;
	double exec;
	double dma;
	double comb;
	double calc;
	double un;
	double pad[2];
} dTime;

typedef struct _combTime
{
	dTime avg;
	dTime max;
	dTime min;
} combTime;


void printTimersDetailed(spu_timers timers);
void printTimersDetailed_flops(spu_timers timers, long long n);
combTime combTimers(spu_timers timers);

void startTimer(spu_timer* timer);
void stopTimer(spu_timer* timer);
float getTime(spu_timer* timer);

void printTimers(spu_timers timers);
void printTimers_flops(spu_timers timers, long long n);

static inline void clearTimers(spu_timers *timers)
{
	spu_timers tmp = {{0,0},{0,0},{0,0},{0,0},{0,0}};
	*timers = tmp;
};

extern spu_timers bl_time;

#endif

