#include "include/bl_mp.h"
#include "include/block_lib.h"

// this module is not properly worked over, it's just an experiment

static void swap_pipeF_pointers(pipeF_pointer *p1, pipeF_pointer *p2)
{
	pipeF_pointer pTmp = *p1;
	*p1 = *p2;
	*p2 = pTmp;
}

static void rot_pipeF_pointers(pipeF_Handler *h)
{
	swap_pipeF_pointers(&h->p1, &h->p2);
	swap_pipeF_pointers(&h->p1, &h->p3);
}

static void init_pipeF_all(pipeF_Handler *h, int bs)
{
	h->p1.p=fix_align(BUF_ALIGN,h->buf1);
	h->p1.size = 0;
	h->p1.start = 0;
	h->p2.p=fix_align(BUF_ALIGN,h->buf2);
	h->p2.size = 0;
	h->p2.start = 0;
	h->p3.p=fix_align(BUF_ALIGN,h->buf3);
	h->p3.size = 0;
	h->p3.start = 0;
	h->bs = bs;
	h->step = 0;
	h->storeCounter = 0;
	h->counter = 0;
}

void init_pipeF_first(pipeF_Handler *h, PrivateArray* a, int toRank, int bs)
{
	init_pipeF_all(h,bs);
	h->a = a;
	h->size = getPASize(a);
	h->role=PIPE_FIRST;
	h->toRank = toRank;
}

void init_pipeF_mid(pipeF_Handler *h, int fromRank, int toRank, int bs)
{
	init_pipeF_all(h,bs);
	h->role=PIPE_MID;
	h->toRank = toRank;
	h->fromRank = fromRank;
}

void init_pipeF_last(pipeF_Handler *h, PrivateArray* a, int fromRank, int bs)
{
	init_pipeF_all(h,bs);
	h->role=PIPE_LAST;
	h->fromRank = fromRank;
	h->a = a;
	h->size = getPASize(a);
}


int step_PipeF_First(pipeF_Handler *h)
{
	if(h->step == 0) // get first
	{
		h->p1.size = (h->bs < h->size ? h->bs : h->size);
		h->p1.start = 0;
		startTimer(&bl_time.exec);
		get_PArrF_dA(h->a, h->p1.p, 0, h->p1.size-1);
		stopTimer(&bl_time.exec);
		h->counter += h->p1.size;
	}
	startTimer(&bl_time.exec);
	if(h->p1.size) // Wait for parr
		wait_PArr_complete(h->a, (Addr64)h->p1.p);
	stopTimer(&bl_time.exec);
	if(h->p3.size) // wait for msg ack?
	{
		blWaitMsgAck(h->toRank);
	}
	
	// rot buffers, p2 always current
	rot_pipeF_pointers(h); 
	h->current=h->p2;
	
	// get next from parr
	h->p1.size = ((h->counter + h->bs) < h->size ? h->bs : (h->size - h->counter));
	h->p1.start = h->counter;
	startTimer(&bl_time.exec);
	if(h->p1.size)
		get_PArrF_dA(h->a, h->p1.p, h->counter, h->counter + h->p1.size-1);
	stopTimer(&bl_time.exec);
	h->counter += h->p1.size;
	
	if(h->p3.size) // send computed buffer to next
	{
		blSendMsg(h->p3.p,h->p3.size*sizeof(float), h->toRank); 
	}

	h->step++;
	
	if(h->current.size == 0) // last done, finish up
	{
		// wait last msg
		blWaitMsgAck(h->toRank);
		// send msg of size 0 up for pipe termination
		blSendMsg(h->p3.p,0, h->toRank); 
	}
	
	return h->current.size;
}

int step_PipeF_Mid(pipeF_Handler *h)
{	
	if(h->step == 0) // wait for first msg
	{
		h->p1.size = blRecvMsg(h->p1.p, h->fromRank) / sizeof(float);
		h->p1.start = 0;
		h->counter = h->p1.size;
	}
	
	if(h->p1.size)
	{
		blWaitMsgDMA(h->fromRank);
	}

	
	if(h->p3.size) // wait for send completion
		blWaitMsgAck(h->toRank);
	
	
	rot_pipeF_pointers(h); 
	h->current=h->p2;
	
	if(h->p2.size) // if current non zero, get next
	{
		h->p1.size = blRecvMsg(h->p1.p, h->fromRank) / sizeof(float);
		h->p1.start = h->counter;
		h->counter += h->p1.size;
	}
	if(h->p3.size)
	{
		blSendMsg(h->p3.p,h->p3.size*sizeof(float), h->toRank); 
		h->storeCounter += h->p3.size;
	}
	if(h->current.size == 0) // last done, finish up
	{	
		// wait current p3 store
		blWaitMsgAck(h->toRank);	
		blSendMsg(h->p3.p,0, h->toRank);
	}	
	h->step++;
	return h->current.size;
}

int step_PipeF_Last(pipeF_Handler *h)
{
	if(h->step == 0) // wait for first msg
	{
		h->p1.size = blRecvMsg(h->p1.p, h->fromRank) / sizeof(float);
		h->p1.start = 0;
		h->counter = h->p1.size;
	}
	
	if(h->p1.size)
	{
		blWaitMsgDMA(h->fromRank);
	}

	startTimer(&bl_time.exec);
	if(h->p3.size && h->a) // wait for store completion
		wait_PArr_complete(h->a, (Addr64)h->p3.p);
	stopTimer(&bl_time.exec);
	
	rot_pipeF_pointers(h); 
	h->current=h->p2;
	
	if(h->p2.size)
	{
		h->p1.size = blRecvMsg(h->p1.p, h->fromRank) / sizeof(float);
		h->p1.start = h->counter;
		h->counter += h->p1.size;
	}
	if(h->p3.size && h->a)
	{
		startTimer(&bl_time.exec);
		store_PArrF_dA(h->a, h->p3.p, h->storeCounter, h->storeCounter + h->p3.size - 1);
		h->storeCounter += h->p3.size;
		stopTimer(&bl_time.exec);
	}
	if(h->current.size == 0) // last done, finish up
	{	
		// wait current p3 store
		startTimer(&bl_time.exec);
		if(h->a)
			wait_PArr_complete(h->a, (Addr64)h->p3.p);
		stopTimer(&bl_time.exec);
	}	
	h->step++;
	return h->current.size;
}


int step_PipeF(pipeF_Handler *h)
{
	if(h->role == PIPE_FIRST)
		return step_PipeF_First(h);
	else if(h->role == PIPE_MID)
		return step_PipeF_Mid(h);
	else if(h->role == PIPE_LAST)
		return step_PipeF_Last(h);
}
