/* **********************************************
 * BlockLib Test Program - Message Passing
 * **********************************************/

 
#include <stdio.h>
#include <NestStep_spulib/neststep_spu.h>
#include "block_lib.h"
#include <spu_intrinsics.h>
// Used for transforming clock-ticks to
// seconds, gotten from /proc/cpuinfo
//#define TIMEBASE 14318000
#define TIMEBASE 79800000
// Initialization value for the counter
#define DEC_INIT_VAL 0XFFFFFFFF


#define MAX(a,b) (a>b ? a:b)

//int N = 17; 
int N = 1024*1024*10;
//int N = 1024*1024*24;

int rank;
int group_size;
spu_timers timers={{0,0},{0,0},{0,0},{0,0},{0,0}};

#define SIG1_OFFSET -0x80bff4

void binPrint(unsigned int val)
{
	int u;
			char out[33];
			for(u=31;u>=0;u--)
				out[31-u]=(val&(1<<u) ? '1':'0');
			out[32]=NULL;
			printf("(%d): %s\n", NestStep_get_rank(), out);
	
}

#define BIGMSG 4096
#define ITRS 1000000
int main(unsigned long long speid, Addr64 argp, Addr64 envp)
{
	
    spu_write_decrementer(DEC_INIT_VAL);
    int i;
	
    NestStep_SPU_init(argp);
    rank = NestStep_get_rank();
	group_size = NestStep_get_size();
	
    Name name;
    name.procedure = 1;
    name.relative = 0;

	NestStep_step();
	NestStep_combine(NULL,NULL);
	NestStep_end_step();
//	Ls_pointers ls[MAX_SPE_THREADS];

//	NestStep_get_all_ls(ls);
//	for(i=0;i<group_size;i++)
//		prx0(ls[i]);
	int u;
/*	startTimer(&timers.total);
	for(i=0; i < 1000000; i++)
	{
		if(rank == 0)
		{
			blSignal(1);
			blWaitSignal(group_size-1);
		}
		else if (rank +1 != group_size)
		{
			blWaitSignal(rank-1);
		//	blSignalAck(0);
			blSignal(rank+1);
		}
		else
		{
			blWaitSignal(rank-1);
		//	blSignalAck(0);
			blSignal(0);
		}
	}
	stopTimer(&timers.total);
	prs("done"); 
//	printTimersDetailed(timers);
	*/
//	clearTimers(&timers);
/*	startTimer(&timers.comb);
	for(i=0; i < 1000000; i++)
	{
		if(rank == 0)
		{
			for(u=1;u<group_size;u++)
				blWaitSignal(u);
			for(u=1;u<group_size;u++)
				blSignalAck(u);
		}
		else
		{
//			blWaitSignal(0);
			blSignal(0);
			blWaitSignalAck(0);
		}
	}
	stopTimer(&timers.comb); */
//	prs("done");
	
//	printTimersDetailed(timers); 
//	clearTimers(&timers);
/*	
	float foo[MAX_SPUS];
	float local=4;
	
	startTimer(&timers.calc);
	for(i=0; i < 1000000; i++)
	{
		blMPDistSync(foo, &local, 4);
	}
	stopTimer(&timers.calc);
*/
	
	int msgBuff[8]={0,1,2,3,4,5,6,7};
	int msgRecvBuff[8]={0,0,0,0,0,0,0,0};
	
	volatile int bigMsg1[BIGMSG];
	volatile int bigMsg2[BIGMSG];
	
	
	NestStep_step();
	{
		startTimer(&timers.dma);
		if(!(group_size%2))
		{
			prd0(BIGMSG)
			prd0(ITRS)
			for(i=0;i<ITRS;i++)
			{
			//	prs("itr start")
				if(!(rank%2))
				{
				//	blSignal(rank+1);
				//	blSignal(1);
				//	blSignal(1);
				//	blSignal(1);
				//	blWaitSignal(rank+1);
					blSendMsg(bigMsg1, BIGMSG*sizeof(int), rank+1);
					blRecvMsg(bigMsg2, rank+1);
					blWaitMsgDMA(rank+1);
					blWaitMsgAck(rank+1);
				}
				else
				{
				//	blSignal(rank-1);
				//	blSignal(0);
				//	blSignal(0);
				//	blSignal(0);
				//	blWaitSignal(rank-1);
				//	blSignal(0);
					blSendMsg(bigMsg1, BIGMSG*sizeof(int), rank-1);
					blRecvMsg(bigMsg2, rank-1);
					blWaitMsgDMA(rank-1);
					blWaitMsgAck(rank-1);
			//		for(i=0;i<8;i++)
			//			prd(msgRecvBuff[i]);
				}
			}
		}
		stopTimer(&timers.dma);	
		NestStep_combine(NULL,NULL);
	}
	NestStep_end_step();
	prs("done");
	
	printTimersDetailed(timers); 
	
    NestStep_SPU_finalize();

    return 0;
} 

